unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TATools, TASeries,Forms, Controls,
  Graphics, Dialogs, StdCtrls, Menus, ExtCtrls, ComCtrls,
  profile_unit;

{Copyright (C) 2017 Frank Ranis

Sie haben das unentgeltliche Recht diese Software
(sowie den bereitgestellten Quelltext) für nicht gewerbliche Zwecke zu nutzen.
Unter der Voraussetzung das sie folgendes anerkennen:
Sie erkennen an , dass der Autor keinerlei Gewährleistung , Verpflichtungen oder
Haftung für Schäden , die durch die Nutzung der Software oder daraus gewonnener
Daten entstehen , übernimmt.

Es wird gewünscht , das geänderte Software (incl. Quelltext) wieder allen
interessierten Benutzern zur Verfügung gestellt wird.
Dabei bitte die Versions-Nummer mit Datum und Namen des neuen Autors anpassen ,
sowie Hinweise zu den Änderungen im Quelltext eintragen .
Das geänderte Programmpaket bitte wieder (gezippt) im RC-Network-WIKI
(Programmname_Vers_xxx.zip) zusätzlich hochladen, alte Versionen stehen lassen.
}

// Version mit Datum , Autor , Änderungen
// Vers. 1.0 , 21.11.2017 , Frank Ranis
// Erstellt mit Lazarus V1.6.4 / Freepascal V3.0.2
// Import: (Selig.dat) , (Konopka.dat) , (Wiechers.koo)
// Export: (Selig.dat) , (Konopka.dat) , (Wiechers.koo)

const FormTitel='Profil Converter , Vers.1.00 , 21.11.2017 , Frank Ranis';

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    ChartToolset1: TChartToolset;
    ChartToolset1PanDragTool1: TPanDragTool;
    ChartToolset1ZoomDragTool1: TZoomDragTool;
    ChartToolset1ZoomMouseWheelTool1: TZoomMouseWheelTool;
    Label1: TLabel;
    Label3: TLabel;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;



var
  Form1: TForm1;
  aktueller_pfad:string;
  Prof:TProf; // Profil-Objekt

implementation

{$R *.lfm}

{ TForm1 }

// Beim Erzeugen des Forms
procedure TForm1.FormCreate(Sender: TObject);
var s:string;
begin
 // den aktuellen Pfad auf den Rootpfad der Exe setzten
 // Im Prameterstring an Stelle 0 steht der Rootpfad und der Exe-Name
 s:=paramstr(0);
 // Wir ziehen den Rootpfad raus
 s:=extractfilepath(s);
 aktueller_pfad:=s;
 // Programm-Titel
 self.Caption:=FormTitel;
end;

// Profil laden
procedure TForm1.MenuItem2Click(Sender: TObject);
var ext:string;
begin
 opendialog1.InitialDir:=aktueller_pfad;
 if opendialog1.Execute
  then
   begin
    // Eventuell neu gewählten Pfad setzten
    aktueller_pfad:=extractfilepath(opendialog1.FileName);

    // alte Daten löschen
    chart1.ClearSeries; // Chart Serien löschen
    chart1.ZoomFull();
    prof.clear; // alte Profildaten löschen

    // das File in die Listbox laden , optische Kontrolle
    listbox1.items.LoadFromFile(opendialog1.FileName);

    // Dateiendung holen
    ext:=extractfileext(opendialog1.FileName);

    // Laden von *.DAT - Profilen
    if uppercase(ext)='.DAT'
     then
      begin
       // Problem , es gibt zwei DAT-Formate
       // 1) Selig DAT mit Normierung auf 1 und Koordinaten-Separator ' '
       //    Infotext in erster Zeile
       //    Koordinaten ab der zweiten Zeile
       // 2) Konopka DAT mit Normierung auf 100 und Koordinaten-Separator ','
       //    Koordinaten ab der ersten Zeile

       // Wir schauen uns die zweite Zeile mal an.
       // wenn hier ein ',' als Koordinten-Separator vorhanden ist , dann
       // wird es eine warscheinlich ein Konopka.DAT sein
       if pos(',',string(listbox1.items[1]))>0
        then
         // Konopka-Dat
         begin
          prof.load_konopka_dat_from_file(opendialog1.FileName);
         end
       else
        // Selig-Dat
        begin
         prof.load_selig_dat_from_file(opendialog1.FileName);
        end;
       // Das Profil an das Chart übertragen
       prof.send_to_Chart(chart1);
      end;

    // Laden von *.KOO - Profilen
    if uppercase(ext)='.KOO'
     then
      begin
       // Wiechers KOO-Format
       prof.load_wiechers_koo_from_file(opendialog1.FileName);
       // Das Profil an das Chart übertragen
       prof.send_to_Chart(chart1);
      end;



    // Aktuellen Profil-Datei-Namen in Caption schreiben , wenn Koordinaten
    // vorhanden sind
    if prof.count>0
     then
      begin
       self.Caption:=FormTitel+' | '+
                     prof.Prof_Dateiname+
                     ' | Anzahl Koordinaten='+
                     inttostr(prof.count);
      end
     else
      self.Caption:=FormTitel;
   end;
end;

// Programm beenden
procedure TForm1.MenuItem3Click(Sender: TObject);
begin
 self.Close;
end;

// Profildatei speichern
procedure TForm1.MenuItem4Click(Sender: TObject);
var i:integer;
begin
 if prof.count=0 then exit; // wenn keine Profilkoordinaten vorhanden sind
 savedialog1.InitialDir:=aktueller_pfad;
 if savedialog1.Execute
  then
   begin
    // Eventuell neu gewählten Pfad setzten
    aktueller_pfad:=extractfilepath(opendialog1.FileName);

    // Je nach gewähltem Dateiformat abspeichern
    case savedialog1.FilterIndex of
      1:begin
         prof.save_selig_dat_to_file(savedialog1.FileName);
         // Selig Dat
        end;
      2:begin
         // Konopka Dat
         prof.save_konopka_dat_to_file(savedialog1.FileName);
        end;
      3:begin
         // Wiechert Koo
         prof.save_wiechert_koo_to_file(savedialog1.FileName);
        end;
    end;
   end;
end;

end.

